##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (HeiseReg)		= PkgName
# sampledir (ksm-heisereg)	= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (heisereg)		= config file name (no extension)
# sampledm (heiseregd)		= the daemon (rc-script, rc-link, systemd.service)
# sample (heisereg)		= all others
##############################################################################

# Specfile for HeiseReg

%define name		ksm-heisereg
%define version		0.0.1
%define release		0.1.0
%define _arch		noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _uxbindir	/usr/bin
%define _uxsbindir	/usr/sbin
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	Use the Heise Retrieval program
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Other
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	heiseregpkg,heiseregcapab
Requires:	zip
Requires:	ksm-lib-sh >= 0.0.1-0.0.0
#Requires:	ksm-heisereg = %{version}-%{release}	# if lang pkg
#Provides:	heiseregd
#Conflicts:	heiseregd-other,libheisereg == 0.0.0
#Obsoletes:	myheiseregd

%description
This package contains programs for the heise retrieval.
The package contains the following programs:

 hreg, reg.2.1.6

At the first beginning you shold install the db file from heise.

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/heisereg.conf
#%config %{_confdir}/heisereg.conf
#%config %{_scnfdir}/heisereg
#%attr(644,root,root)%{_confdir}/heisereg.conf
#%attr(644,root,root)%{_scnfdir}/heisereg

#%attr(744,root,root)%{_rcdir}/heiseregd
#%attr(777,root,root)%{_sbindir}/rcheiseregd
#%attr(744,root,root)%{_sbindir}/heiseregd.sh

%attr(755,root,root)%{_bindir}/hreg
%attr(755,root,root)%{_bindir}/reg.2.1.6

%{_datadir}/RELEASE
%{_datadir}/VERSION
#%attr(744,root,root)%{_datadir}/heiseregd.rc
#%{_datadir}/heiseregd.service

#/usr/share/applications/heisereg.desktop

#%{_icondir}/16x16/apps/heisereg.png
#%{_icondir}/22x22/apps/heisereg.png
#%{_icondir}/32x32/apps/heisereg.png
#%{_icondir}/48x48/apps/heisereg.png
#%{_icondir}/64x64/apps/heisereg.png
#%{_icondir}/128x128/apps/heisereg.png
#%{_icondir}/256x256/apps/heisereg.png
#%{_icondir}/512x512/apps/heisereg.png
#/usr/share/pixmaps/heisereg.png

%docdir %{_man1dir}
%{_man1dir}/hreg.1.gz
%{_man1dir}/reg.2.1.6.1.gz

%docdir %{_man8dir}
#%{_man8dir}/heiseregd.sh.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
%{_docdir}/README.de

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Execute install. triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Execute uninstallation triggers (%triggerun) of O
#  7. Execute uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files from O not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

#ngroup='' nuser='' npwd='' ncomm='' nhomedir='' nlogsh='' ngid=0 nuid=0 ret=0

# backup config files
#test -e %{_confdir}/heisereg.conf && cp %{_confdir}/heisereg.conf %{_confdir}/heisereg.conf.rpmsave
#test -e %{_scnfdir}/heisereg && cp %{_scnfdir}/heisereg %{_scnfdir}/heisereg.rpmsave

# disable heisereg daemon and stop heiseregd
#test -x %{_bindir}/toggleheisereg && %{_bindir}/toggleheisereg -d -q > /dev/null 2>&1
#test -x %{_rcdir}/heiseregd && %{_rcdir}/heiseregd stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/heisereg.directory \
#	/usr/share/applications/heisereg.desktop \
#	/usr/share/applications/heisereg-admin.desktop

# remove entries from file
#f=file
#t=/tmp/ksm-heisereg
#s=ksm-heisereg
#grep -q $s $f
#ret=$?
#if [ "$ret" -eq 0 ]; then
#	cat $f | grep -v $s > $t
#	cp $t $f
#	rm -f $t
#fi
#ret=0

# INIT SCRIPT/SYSTEMD UNIT - uninstall HeiseReg
#if [ -d %{_sysddir} ]; then				# systemd
#	if [ -e %{_sysddir}/heiseregd.service ]; then
#		systemctl stop heiseregd.service
#		systemctl disable heiseregd.service
#		rm %{_sysddir}/heiseregd.service
#		systemctl daemon-reload
#	fi
#else							# SysV init
#	test -x %{_rcdir}/heiseregd && %{_rcdir}/heiseregd stop > /dev/null 2>&1
#	insserv -r heiseregd > /dev/null 2>&1
#	rm -f %{_rcdir}/heiseregd
#	rm -f %{_sbindir}/rcheiseregd
#fi

if [ "$1" == 1 ]; then					# install package
	mkdir -p /var/daten/heisereg
	if [ ! -e /var/daten/heisereg/heiseinfo.txt ]; then
		cp %{_datadir}/heiseinfo.txt /var/daten/heisereg/
	fi
	if [ ! -e /var/daten/heisereg/inhalt.frm.fmt ]; then
		cp %{_datadir}/inhalt.frm.fmt /var/daten/heisereg/
	fi
	if [ ! -e /var/daten/heisereg/stand.txt ]; then
		cp %{_datadir}/stand.txt /var/daten/heisereg/
	fi

	echo "Set user and group of all files of the heisereg"
	echo "archive to the maintainer of this archive"
#else							# upgrade package
fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname and all config vars from new config file
#cf=%{_confdir}/heisereg.conf
#cnfvars='MyVar1 MyVar2'

#c='' s='' t='' cnt=0 i=0 ret=0
#rcfile='' updcmd='' u='' usr=''

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

# enable heisereg daemon
#test -x %{_bindir}/toggleheisereg && %{_bindir}/toggleheisereg -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
#ln -sf %{_libdir}/libfuncstd-sh-%{version} %{_libdir}/libfuncstd-sh

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/heisereg.directory \
#	/usr/share/applications/heisereg.desktop \
#	/usr/share/applications/heisereg-admin.desktop

# add entries to file
#f=file
#te=file.add
#cat %{_datadir}/$te >> $f

# INIT SCRIPT/SYSTEMD UNIT - install HeiseReg
#if [ -d %{_sysddir} ]; then				# systemd
#	cp --preserve=mode %{_datadir}/heiseregd.service %{_sysddir}/
#	systemctl daemon-reload
#	systemctl enable heiseregd.service
#	echo "heiseregd is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start heiseregd within yast or manual with:"
#	echo "systemctl start heiseregd.service"
#else							# SysV init
#	cp --preserve=mode %{_datadir}/heiseregd.rc %{_rcdir}/heiseregd
#	ln -sf %{_rcdir}/heiseregd %{_sbindir}/rcheiseregd
#	insserv heiseregd > /dev/null 2>&1
#	echo "heiseregd is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start heiseregd within yast or manual with rcheiseregd start"
#fi

#if [ "$1" == 1 ]; then					# install package
#	echo "Configure $cf"
#	echo "Users must create HOME/.heiseregrc with update-heisereg"
#else							# upgrade package
#	# update global conf
#	if [ -e $cf.rpmsave ]; then
#		#cp $cf $cf.rpmnew
#		. $cf
#		. $cf.rpmsave
#
#		# update conf vars START -------------------------------------
#		if [ -x %{_bindir}/replcnfvar ]; then
#			for c in $cnfvars; do
#				t="\$$c"
#				eval s="$t"
#				s=\"$s\"
#				%{_bindir}/replcnfvar $cf $c "$s"
#			done
#		else
#			echo "Error - cmd replcnfvar not found or not executable!" >&2
#			echo "Conf file not updated!" >&2
#		fi
#		# update conf vars STOP --------------------------------------
#
#		# update array vars START ------------------------------------
#		# array var MainArr
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------
#
#		# compare new conf vars <--> old conf vars
#		diff $cf $cf.rpmsave > /dev/null 2>&1
#		ret=$?
#		if [ "$ret" -eq 0 ]; then
#			rm $cf.rpmsave
#		else
#			echo "Check $cf"
#		fi
#	fi
#
#	# update all users conf START ----------------------------------------
#	rcfile='.heiseregrc'
#	updcmd="%{_bindir}/update-heisereg -q"
#	usr=`/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1`
#	for u in "$usr"; do
#		if [ -e /home/$u/$rcfile ]; then
#			/bin/su $u -c "$updcmd"
#		fi
#	done
#	if [ -e /root/$rcfile ]; then
#		$updcmd
#	fi
#	# update all users conf STOP -----------------------------------------
#
#	echo "If new version then users must update HOME/.heiseregrc with update-heisereg"
#fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

#if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/heisereg.conf && cp %{_confdir}/heisereg.conf %{_confdir}/heisereg.conf.rpmsave
	#test -e %{_scnfdir}/heisereg && cp %{_scnfdir}/heisereg %{_scnfdir}/heisereg.rpmsave

	# disable heisereg daemon and stop heiseregd
	#test -x %{_bindir}/toggleheisereg && %{_bindir}/toggleheisereg -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/heiseregd && %{_rcdir}/heiseregd stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	#rm -f %{_libdir}/libfuncstd-sh

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/heisereg.directory \
	#	/usr/share/applications/heisereg.desktop \
	#	/usr/share/applications/heisereg-admin.desktop

	# remove entries from file
	#f=file
	#t=/tmp/ksm-heisereg
	#s=ksm-heisereg
	#grep -q $s $f
	#ret=$?
	#if [ "$ret" -eq 0 ]; then
	#	cat $f | grep -v $s > $t
	#	cp $t $f
	#	rm -f $t
	#fi
	#ret=0

	# INIT SCRIPT/SYSTEMD UNIT - uninstall HeiseReg
	#if [ -d %{_sysddir} ]; then				# systemd
	#	if [ -e %{_sysddir}/heiseregd.service ]; then
	#		systemctl stop heiseregd.service
	#		systemctl disable heiseregd.service
	#		rm %{_sysddir}/heiseregd.service
	#		systemctl daemon-reload
	#	fi
	#else							# SysV init
	#	test -x %{_rcdir}/heiseregd && %{_rcdir}/heiseregd stop > /dev/null 2>&1
	#	insserv -r heiseregd > /dev/null 2>&1
	#	rm -f %{_rcdir}/heiseregd
	#	rm -f %{_sbindir}/rcheiseregd
	#fi
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/ksm-heisereg
#else							# upgrade package
fi
exit 0

%changelog
* Sat Feb 05 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.1.0
- hreg has been revised/improved.

* Tue May 05 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.0.0
- The package has been revised/improved.

* Tue May 05 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.0-0.0.0
- This is the 1. version.
  The package contains following commands
  all moved from ksm-utils:
  hreg		Execute c't retrieval program
  reg.2.1.6	The Heise retrieval program
